diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-phy.cc ns-3.42/src/wifi/model/he/he-phy.cc
--- ns-3.41/src/wifi/model/he/he-phy.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-phy.cc	2024-05-29 15:29:47.200073700 -0700
@@ -38,6 +38,9 @@
 
 #include <algorithm>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
@@ -382,7 +385,7 @@
                         << GetDuration(WIFI_PPDU_FIELD_TRAINING, txVector).As(Time::NS));
             auto event = CreateInterferenceEvent(ppdu, rxDuration, rxPowersW, !hePortionStarted);
             uint16_t staId = GetStaId(ppdu);
-            NS_ASSERT(m_beginMuPayloadRxEvents.find(staId) == m_beginMuPayloadRxEvents.end());
+            NS_ASSERT(!m_beginMuPayloadRxEvents.contains(staId));
             m_beginMuPayloadRxEvents[staId] =
                 Simulator::Schedule(GetDuration(WIFI_PPDU_FIELD_TRAINING, txVector),
                                     &HePhy::StartReceiveMuPayload,
@@ -530,14 +533,14 @@
         (GetCurrentEvent()->GetPpdu()->GetUid() != ppdu->GetUid()))
     {
         NS_LOG_DEBUG("Drop packet because already receiving another HE TB PPDU");
-        m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), RXING);
+        m_wifiPhy->NotifyRxPpduDrop(ppdu, RXING);
     }
     else if (const auto isResponseToTrigger = (m_previouslyTxPpduUid == ppdu->GetUid());
              isResponseToTrigger && GetCurrentEvent() &&
              (GetCurrentEvent()->GetPpdu()->GetUid() != ppdu->GetUid()))
     {
         NS_LOG_DEBUG("Drop packet because already receiving another response to a trigger frame");
-        m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), RXING);
+        m_wifiPhy->NotifyRxPpduDrop(ppdu, RXING);
     }
 }
 
@@ -668,8 +671,7 @@
                 return PhyFieldRxStatus(false, FILTERED, DROP);
             }
             uint16_t staId = ppdu->GetStaId();
-            if (m_trigVector->GetHeMuUserInfoMap().find(staId) ==
-                m_trigVector->GetHeMuUserInfoMap().end())
+            if (!m_trigVector->GetHeMuUserInfoMap().contains(staId))
             {
                 NS_LOG_DEBUG("TB PPDU received from un unexpected STA ID");
                 return PhyFieldRxStatus(false, FILTERED, DROP);
@@ -830,7 +832,7 @@
             Simulator::Schedule(timeToEndRx, &HePhy::ResetReceive, this, event));
         // Cancel all scheduled events for MU payload reception
         NS_ASSERT(!m_beginMuPayloadRxEvents.empty() &&
-                  m_beginMuPayloadRxEvents.begin()->second.IsRunning());
+                  m_beginMuPayloadRxEvents.begin()->second.IsPending());
         for (auto& beginMuPayloadRxEvent : m_beginMuPayloadRxEvents)
         {
             beginMuPayloadRxEvent.second.Cancel();
@@ -848,7 +850,7 @@
         NS_ASSERT(!m_beginMuPayloadRxEvents.empty());
         for (auto& beginMuPayloadRxEvent : m_beginMuPayloadRxEvents)
         {
-            NS_ASSERT(beginMuPayloadRxEvent.second.IsRunning());
+            NS_ASSERT(beginMuPayloadRxEvent.second.IsPending());
         }
     }
 
@@ -1517,8 +1519,7 @@
         if (txVector.IsDlMu())
         {
             NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
-            WifiTxVector::HeMuUserInfoMap userInfoMap = txVector.GetHeMuUserInfoMap();
-            NS_ABORT_MSG_IF(userInfoMap.find(staIdPsdu.first) == userInfoMap.end(),
+            NS_ABORT_MSG_IF(!txVector.GetHeMuUserInfoMap().contains(staIdPsdu.first),
                             "STA-ID in psduMap (" << staIdPsdu.first
                                                   << ") should be referenced in txVector");
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-ppdu.cc ns-3.42/src/wifi/model/he/he-ppdu.cc
--- ns-3.41/src/wifi/model/he/he-ppdu.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-ppdu.cc	2024-05-29 15:29:47.200073700 -0700
@@ -466,7 +466,7 @@
     // HE TB PPDU reception needs information from the TRIGVECTOR to be able to receive the PPDU
     const auto staId = GetStaId();
     if (trigVector.has_value() && trigVector->IsUlMu() &&
-        (trigVector->GetHeMuUserInfoMap().count(staId) > 0))
+        (trigVector->GetHeMuUserInfoMap().contains(staId)))
     {
         // These information are not carried in HE-SIG-A for a HE TB PPDU,
         // but they are carried in the Trigger frame soliciting the HE TB PPDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/he-ru.cc ns-3.42/src/wifi/model/he/he-ru.cc
--- ns-3.41/src/wifi/model/he/he-ru.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/he-ru.cc	2024-05-29 15:29:47.200073700 -0700
@@ -393,25 +393,29 @@
 HeRu::GetRuSpecs(uint8_t ruAllocation)
 {
     std::optional<std::size_t> idx;
-    switch (ruAllocation)
+    if (((ruAllocation >= 0) && (ruAllocation <= 15)) || (ruAllocation == 112))
     {
-    case 0 ... 15:
-    case 112:
         idx = ruAllocation;
-        break;
-    case 16 ... 95:
-    case 192 ... 215:
+    }
+    else if (((ruAllocation >= 16) && (ruAllocation <= 95)) ||
+             ((ruAllocation >= 192) && (ruAllocation <= 215)))
+    {
         idx = ruAllocation & 0xF8;
-        break;
-    case 96 ... 111:
+    }
+    else if ((ruAllocation >= 96) && (ruAllocation <= 111))
+    {
         idx = ruAllocation & 0xF0;
-        break;
-    case 113 ... 115:
-        break;
-    case 128 ... 191:
+    }
+    else if ((ruAllocation >= 113) && (ruAllocation <= 115))
+    {
+        // Do not set idx to return an undefined RU allocation
+    }
+    else if ((ruAllocation >= 128) && (ruAllocation <= 191))
+    {
         idx = ruAllocation & 0xC0;
-        break;
-    default:
+    }
+    else
+    {
         NS_FATAL_ERROR("Reserved RU allocation " << +ruAllocation);
     }
     return idx.has_value() ? m_heRuAllocations.at(idx.value()) : std::vector<HeRu::RuSpec>{};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/multi-user-scheduler.cc ns-3.42/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.41/src/wifi/model/he/multi-user-scheduler.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/multi-user-scheduler.cc	2024-05-29 15:29:47.200073700 -0700
@@ -210,7 +210,7 @@
     m_allowedWidth = allowedWidth;
     m_linkId = linkId;
 
-    if (m_accessReqTimer.IsRunning() && m_restartTimerUponAccess)
+    if (m_accessReqTimer.IsPending() && m_restartTimerUponAccess)
     {
         // restart access timer
         m_accessReqTimer.Cancel();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/mu-snr-tag.cc ns-3.42/src/wifi/model/he/mu-snr-tag.cc
--- ns-3.41/src/wifi/model/he/mu-snr-tag.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/mu-snr-tag.cc	2024-05-29 15:29:47.200073700 -0700
@@ -57,7 +57,7 @@
 bool
 MuSnrTag::IsPresent(uint16_t staId) const
 {
-    return (m_snrMap.find(staId) != m_snrMap.end());
+    return m_snrMap.contains(staId);
 }
 
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.41/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-05-29 15:29:47.200073700 -0700
@@ -302,7 +302,7 @@
     // only consider stations that have setup the current link
     WifiTxVector txVector = GetTxVectorForUlMu([this](const MasterInfo& info) {
         const auto& staList = m_apMac->GetStaList(m_linkId);
-        return staList.find(info.aid) != staList.cend();
+        return staList.contains(info.aid);
     });
 
     if (txVector.GetHeMuUserInfoMap().empty())
@@ -346,13 +346,13 @@
     if (m_availableTime != Time::Min())
     {
         // TryAddMpdu only considers the time to transmit the Trigger Frame
-        NS_ASSERT(m_txParams.m_protection &&
-                  m_txParams.m_protection->protectionTime != Time::Min());
+        NS_ASSERT(m_txParams.m_protection && m_txParams.m_protection->protectionTime.has_value());
         NS_ASSERT(m_txParams.m_acknowledgment &&
-                  m_txParams.m_acknowledgment->acknowledgmentTime.IsZero());
-        NS_ASSERT(m_txParams.m_txDuration != Time::Min());
+                  m_txParams.m_acknowledgment->acknowledgmentTime.has_value() &&
+                  m_txParams.m_acknowledgment->acknowledgmentTime->IsZero());
+        NS_ASSERT(m_txParams.m_txDuration.has_value());
 
-        if (m_txParams.m_protection->protectionTime + m_txParams.m_txDuration // BSRP TF tx time
+        if (*m_txParams.m_protection->protectionTime + *m_txParams.m_txDuration // BSRP TF tx time
                 + m_apMac->GetWifiPhy(m_linkId)->GetSifs() + qosNullTxDuration >
             m_availableTime)
         {
@@ -390,8 +390,7 @@
     // reported a null queue size
     WifiTxVector txVector = GetTxVectorForUlMu([this](const MasterInfo& info) {
         const auto& staList = m_apMac->GetStaList(m_linkId);
-        return staList.find(info.aid) != staList.cend() &&
-               m_apMac->GetMaxBufferStatus(info.address) > 0;
+        return staList.contains(info.aid) && m_apMac->GetMaxBufferStatus(info.address) > 0;
     });
 
     if (txVector.GetHeMuUserInfoMap().empty())
@@ -458,16 +457,15 @@
     if (m_availableTime != Time::Min())
     {
         // TryAddMpdu only considers the time to transmit the Trigger Frame
-        NS_ASSERT(m_txParams.m_protection &&
-                  m_txParams.m_protection->protectionTime != Time::Min());
+        NS_ASSERT(m_txParams.m_protection && m_txParams.m_protection->protectionTime.has_value());
         NS_ASSERT(m_txParams.m_acknowledgment &&
-                  m_txParams.m_acknowledgment->acknowledgmentTime != Time::Min());
-        NS_ASSERT(m_txParams.m_txDuration != Time::Min());
+                  m_txParams.m_acknowledgment->acknowledgmentTime.has_value());
+        NS_ASSERT(m_txParams.m_txDuration.has_value());
 
         maxDuration = Min(maxDuration,
-                          m_availableTime - m_txParams.m_protection->protectionTime -
-                              m_txParams.m_txDuration - m_apMac->GetWifiPhy(m_linkId)->GetSifs() -
-                              m_txParams.m_acknowledgment->acknowledgmentTime);
+                          m_availableTime - *m_txParams.m_protection->protectionTime -
+                              *m_txParams.m_txDuration - m_apMac->GetWifiPhy(m_linkId)->GetSifs() -
+                              *m_txParams.m_acknowledgment->acknowledgmentTime);
         if (maxDuration.IsNegative())
         {
             NS_LOG_DEBUG("Remaining TXOP duration is not enough for UL MU exchange");
@@ -944,9 +942,10 @@
         }
     }
 
+    NS_ASSERT(dlMuInfo.txParams.m_txDuration.has_value());
     AcIndex primaryAc = m_edca->GetAccessCategory();
     UpdateCredits(m_staListDl[primaryAc],
-                  dlMuInfo.txParams.m_txDuration,
+                  *dlMuInfo.txParams.m_txDuration,
                   dlMuInfo.txParams.m_txVector);
 
     NS_LOG_DEBUG("Next station to serve has AID=" << m_staListDl[primaryAc].front().aid);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-02-09 14:44:08.585795000 -0800
+++ ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-05-29 15:29:47.204074000 -0700
@@ -19,6 +19,8 @@
 
 #include "ht-frame-exchange-manager.h"
 
+#include "ht-configuration.h"
+
 #include "ns3/abort.h"
 #include "ns3/assert.h"
 #include "ns3/ctrl-headers.h"
@@ -29,13 +31,14 @@
 #include "ns3/sta-wifi-mac.h"
 #include "ns3/vht-configuration.h"
 #include "ns3/wifi-mac-queue.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-utils.h"
 
 #include <array>
 #include <optional>
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+#define NS_LOG_APPEND_CONTEXT WIFI_FEM_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
@@ -110,21 +113,29 @@
     Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
     bool establish;
 
-    if (!m_mac->GetHtSupported(recipient))
+    // NOLINTBEGIN(bugprone-branch-clone)
+    if (!m_mac->GetHtConfiguration() ||
+        (!GetWifiRemoteStationManager()->GetHtSupported(recipient) &&
+         !GetWifiRemoteStationManager()->GetStationHe6GhzCapabilities(recipient)))
     {
+        // no Block Ack if this device or the recipient are not HT STAs and do not operate
+        // in the 6 GHz band
         establish = false;
     }
     else if (auto agreement = qosTxop->GetBaManager()->GetAgreementAsOriginator(recipient, tid);
              agreement && !agreement->get().IsReset())
     {
+        // Block Ack agreement already established
         establish = false;
     }
+    // NOLINTEND(bugprone-branch-clone)
     else
     {
         WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, recipient, tid};
         uint32_t packets = qosTxop->GetWifiMacQueue()->GetNPackets(queueId);
         establish =
-            ((qosTxop->GetBlockAckThreshold() > 0 && packets >= qosTxop->GetBlockAckThreshold()) ||
+            (m_mac->Is6GhzBand(m_linkId) ||
+             (qosTxop->GetBlockAckThreshold() > 0 && packets >= qosTxop->GetBlockAckThreshold()) ||
              (m_mpduAggregator->GetMaxAmpduSize(recipient, tid, WIFI_MOD_CLASS_HT) > 0 &&
               packets > 1) ||
              m_mac->GetVhtConfiguration());
@@ -257,12 +268,9 @@
     {
         originator = *originatorMld;
     }
-    bool htSupported = GetWifiRemoteStationManager()->GetHtSupported() &&
-                       GetWifiRemoteStationManager()->GetHtSupported(originator);
     GetBaManager(tid)->CreateRecipientAgreement(respHdr,
                                                 originator,
                                                 reqHdr->GetStartingSequence(),
-                                                htSupported,
                                                 m_rxMiddle);
 
     auto agreement = GetBaManager(tid)->GetAgreementAsRecipient(originator, tid);
@@ -885,8 +893,8 @@
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
         NS_ASSERT(txParams.m_acknowledgment &&
-                  txParams.m_acknowledgment->acknowledgmentTime != Time::Min());
-        return txParams.m_acknowledgment->acknowledgmentTime;
+                  txParams.m_acknowledgment->acknowledgmentTime.has_value());
+        return *txParams.m_acknowledgment->acknowledgmentTime;
     }
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
@@ -920,7 +928,7 @@
     // and SendCtsToSelf() can reuse this value.
     NS_ASSERT(m_txParams.m_acknowledgment);
 
-    if (m_txParams.m_acknowledgment->acknowledgmentTime == Time::Min())
+    if (!m_txParams.m_acknowledgment->acknowledgmentTime.has_value())
     {
         CalculateAcknowledgmentTime(m_txParams.m_acknowledgment.get());
     }
@@ -1143,9 +1151,9 @@
     NS_LOG_FUNCTION(this << *mpdu << &txParams << ppduDurationLimit);
 
     Mac48Address receiver = mpdu->GetHeader().GetAddr1();
-    uint32_t ampduSize = txParams.GetSizeIfAddMpdu(mpdu);
+    uint32_t ampduSize = txParams.GetSize(receiver);
 
-    if (txParams.GetSize(receiver) > 0)
+    if (!txParams.LastAddedIsFirstMpdu(receiver))
     {
         // we are attempting to perform A-MPDU aggregation, hence we have to check
         // that we meet the limit on the max A-MPDU size
@@ -1210,9 +1218,14 @@
     NS_ASSERT(msdu && msdu->GetHeader().IsQosData());
     NS_LOG_FUNCTION(this << *msdu << &txParams << availableTime);
 
+    // tentatively aggregate the given MPDU
+    auto prevTxDuration = txParams.m_txDuration;
+    txParams.AggregateMsdu(msdu);
+    UpdateTxDuration(msdu->GetHeader().GetAddr1(), txParams);
+
     // check if aggregating the given MSDU requires a different protection method
     NS_ASSERT(txParams.m_protection);
-    Time protectionTime = txParams.m_protection->protectionTime;
+    auto protectionTime = txParams.m_protection->protectionTime;
 
     std::unique_ptr<WifiProtection> protection;
     protection = GetProtectionManager()->TryAggregateMsdu(msdu, txParams);
@@ -1228,11 +1241,11 @@
         txParams.m_protection.swap(protection);
         protectionSwapped = true;
     }
-    NS_ASSERT(protectionTime != Time::Min());
+    NS_ASSERT(protectionTime.has_value());
 
     // check if aggregating the given MSDU requires a different acknowledgment method
     NS_ASSERT(txParams.m_acknowledgment);
-    Time acknowledgmentTime = txParams.m_acknowledgment->acknowledgmentTime;
+    auto acknowledgmentTime = txParams.m_acknowledgment->acknowledgmentTime;
 
     std::unique_ptr<WifiAcknowledgment> acknowledgment;
     acknowledgment = GetAckManager()->TryAggregateMsdu(msdu, txParams);
@@ -1248,18 +1261,20 @@
         txParams.m_acknowledgment.swap(acknowledgment);
         acknowledgmentSwapped = true;
     }
-    NS_ASSERT(acknowledgmentTime != Time::Min());
+    NS_ASSERT(acknowledgmentTime.has_value());
 
     Time ppduDurationLimit = Time::Min();
     if (availableTime != Time::Min())
     {
-        ppduDurationLimit = availableTime - protectionTime - acknowledgmentTime;
+        ppduDurationLimit = availableTime - *protectionTime - *acknowledgmentTime;
     }
 
     if (!IsWithinLimitsIfAggregateMsdu(msdu, txParams, ppduDurationLimit))
     {
-        // adding MPDU failed, restore protection and acknowledgment methods
-        // if they were swapped
+        // adding MPDU failed, undo the addition of the MPDU and restore protection and
+        // acknowledgment methods if they were swapped
+        txParams.UndoAddMpdu();
+        txParams.m_txDuration = prevTxDuration;
         if (protectionSwapped)
         {
             txParams.m_protection.swap(protection);
@@ -1271,10 +1286,6 @@
         return false;
     }
 
-    // the given MPDU can be added, hence update the txParams
-    txParams.AggregateMsdu(msdu);
-    UpdateTxDuration(msdu->GetHeader().GetAddr1(), txParams);
-
     return true;
 }
 
@@ -1286,10 +1297,11 @@
     NS_ASSERT(msdu && msdu->GetHeader().IsQosData());
     NS_LOG_FUNCTION(this << *msdu << &txParams << ppduDurationLimit);
 
-    std::pair<uint16_t, uint32_t> ret = txParams.GetSizeIfAggregateMsdu(msdu);
-    Mac48Address receiver = msdu->GetHeader().GetAddr1();
-    uint8_t tid = msdu->GetHeader().GetQosTid();
-    WifiModulationClass modulation = txParams.m_txVector.GetModulationClass();
+    auto receiver = msdu->GetHeader().GetAddr1();
+    auto tid = msdu->GetHeader().GetQosTid();
+    auto modulation = txParams.m_txVector.GetModulationClass();
+    auto psduInfo = txParams.GetPsduInfo(receiver);
+    NS_ASSERT_MSG(psduInfo, "No PSDU info for receiver " << receiver);
 
     // Check that the limit on A-MSDU size is met
     uint16_t maxAmsduSize = m_msduAggregator->GetMaxAmsduSize(receiver, tid, modulation);
@@ -1300,7 +1312,7 @@
         return false;
     }
 
-    if (ret.first > maxAmsduSize)
+    if (psduInfo->amsduSize > maxAmsduSize)
     {
         NS_LOG_DEBUG("No other MSDU can be aggregated: maximum A-MSDU size (" << maxAmsduSize
                                                                               << ") reached ");
@@ -1309,18 +1321,19 @@
 
     const WifiTxParameters::PsduInfo* info = txParams.GetPsduInfo(msdu->GetHeader().GetAddr1());
     NS_ASSERT(info);
+    auto ampduSize = txParams.GetSize(receiver);
 
     if (info->ampduSize > 0)
     {
         // the A-MSDU being built is aggregated to other MPDUs in an A-MPDU.
         // Check that the limit on A-MPDU size is met.
-        if (!IsWithinAmpduSizeLimit(ret.second, receiver, tid, modulation))
+        if (!IsWithinAmpduSizeLimit(ampduSize, receiver, tid, modulation))
         {
             return false;
         }
     }
 
-    return IsWithinSizeAndTimeLimits(ret.second, receiver, txParams, ppduDurationLimit);
+    return IsWithinSizeAndTimeLimits(ampduSize, receiver, txParams, ppduDurationLimit);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/ht/ht-phy.cc ns-3.42/src/wifi/model/ht/ht-phy.cc
--- ns-3.41/src/wifi/model/ht/ht-phy.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/ht/ht-phy.cc	2024-05-29 15:29:47.204074000 -0700
@@ -29,6 +29,9 @@
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-utils.h"
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
@@ -821,7 +824,6 @@
 PhyEntity::CcaIndication
 HtPhy::GetCcaIndication(const Ptr<const WifiPpdu> ppdu)
 {
-    NS_LOG_FUNCTION(this);
     if (m_wifiPhy->GetChannelWidth() < 40)
     {
         return OfdmPhy::GetCcaIndication(ppdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/interference-helper.cc ns-3.42/src/wifi/model/interference-helper.cc
--- ns-3.41/src/wifi/model/interference-helper.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/interference-helper.cc	2024-05-29 15:29:47.204074000 -0700
@@ -174,8 +174,7 @@
 
 InterferenceHelper::InterferenceHelper()
     : m_errorRateModel(nullptr),
-      m_numRxAntennas(1),
-      m_rxing(false)
+      m_numRxAntennas(1)
 {
     NS_LOG_FUNCTION(this);
 }
@@ -212,15 +211,18 @@
 InterferenceHelper::Add(Ptr<const WifiPpdu> ppdu,
                         Time duration,
                         RxPowerWattPerChannelBand& rxPowerW,
+                        const FrequencyRange& freqRange,
                         bool isStartHePortionRxing)
 {
     Ptr<Event> event = Create<Event>(ppdu, duration, std::move(rxPowerW));
-    AppendEvent(event, isStartHePortionRxing);
+    AppendEvent(event, freqRange, isStartHePortionRxing);
     return event;
 }
 
 void
-InterferenceHelper::AddForeignSignal(Time duration, RxPowerWattPerChannelBand& rxPowerW)
+InterferenceHelper::AddForeignSignal(Time duration,
+                                     RxPowerWattPerChannelBand& rxPowerW,
+                                     const FrequencyRange& freqRange)
 {
     // Parameters other than duration and rxPowerW are unused for this type
     // of signal, so we provide dummy versions
@@ -230,7 +232,7 @@
     Ptr<WifiPpdu> fakePpdu = Create<WifiPpdu>(Create<WifiPsdu>(Create<Packet>(0), hdr),
                                               WifiTxVector(),
                                               WifiPhyOperatingChannel());
-    Add(fakePpdu, duration, rxPowerW);
+    Add(fakePpdu, duration, rxPowerW, freqRange);
 }
 
 bool
@@ -242,15 +244,15 @@
 bool
 InterferenceHelper::HasBand(const WifiSpectrumBandInfo& band) const
 {
-    return (m_niChanges.count(band) > 0);
+    return m_niChanges.contains(band);
 }
 
 void
 InterferenceHelper::AddBand(const WifiSpectrumBandInfo& band)
 {
     NS_LOG_FUNCTION(this << band);
-    NS_ASSERT(m_niChanges.count(band) == 0);
-    NS_ASSERT(m_firstPowers.count(band) == 0);
+    NS_ASSERT(!m_niChanges.contains(band));
+    NS_ASSERT(!m_firstPowers.contains(band));
     NiChanges niChanges;
     auto result = m_niChanges.insert({band, niChanges});
     NS_ASSERT(result.second);
@@ -344,9 +346,11 @@
 }
 
 void
-InterferenceHelper::AppendEvent(Ptr<Event> event, bool isStartHePortionRxing)
+InterferenceHelper::AppendEvent(Ptr<Event> event,
+                                const FrequencyRange& freqRange,
+                                bool isStartHePortionRxing)
 {
-    NS_LOG_FUNCTION(this << event << isStartHePortionRxing);
+    NS_LOG_FUNCTION(this << event << freqRange << isStartHePortionRxing);
     for (const auto& [band, power] : event->GetRxPowerWPerBand())
     {
         auto niIt = m_niChanges.find(band);
@@ -356,7 +360,7 @@
         auto previousPowerPosition = GetPreviousPosition(event->GetStartTime(), niIt);
         previousPowerStart = previousPowerPosition->second.GetPower();
         previousPowerEnd = GetPreviousPosition(event->GetEndTime(), niIt)->second.GetPower();
-        if (!m_rxing)
+        if (const auto rxing = (m_rxing.contains(freqRange) && m_rxing.at(freqRange)); !rxing)
         {
             m_firstPowers.find(band)->second = previousPowerStart;
             // Always leave the first zero power noise event in the list
@@ -413,9 +417,9 @@
     double noiseFloor = m_noiseFigure * Nt;
     double noise = noiseFloor + noiseInterference;
     double snr = signal / noise; // linear scale
-    NS_LOG_DEBUG("bandwidth(MHz)=" << channelWidth << ", signal(W)= " << signal << ", noise(W)="
-                                   << noiseFloor << ", interference(W)=" << noiseInterference
-                                   << ", snr=" << RatioToDb(snr) << "dB");
+    NS_LOG_DEBUG("bandwidth=" << channelWidth << "MHz, signal=" << signal << "W, noise="
+                              << noiseFloor << "W, interference=" << noiseInterference
+                              << "W, snr=" << RatioToDb(snr) << "dB");
     if (m_errorRateModel->IsAwgn())
     {
         double gain = 1;
@@ -441,11 +445,12 @@
     double noiseInterferenceW = firstPower_it->second;
     auto niIt = m_niChanges.find(band);
     NS_ABORT_IF(niIt == m_niChanges.end());
+    const auto now = Simulator::Now();
     auto it = niIt->second.find(event->GetStartTime());
     double muMimoPowerW = (event->GetPpdu()->GetType() == WIFI_PPDU_TYPE_UL_MU)
                               ? CalculateMuMimoPowerW(event, band)
                               : 0.0;
-    for (; it != niIt->second.end() && it->first < Simulator::Now(); ++it)
+    for (; it != niIt->second.end() && it->first < now; ++it)
     {
         if (IsSameMuMimoTransmission(event, it->second.GetEvent()) &&
             (event != it->second.GetEvent()))
@@ -589,7 +594,7 @@
     }
     Time windowStart = phyPayloadStart + window.first;
     Time windowEnd = phyPayloadStart + window.second;
-    NS_ABORT_IF(m_firstPowers.count(band) == 0);
+    NS_ABORT_IF(!m_firstPowers.contains(band));
     double noiseInterferenceW = m_firstPowers.at(band);
     double powerW = event->GetRxPowerW(band);
     while (++j != niIt.cend())
@@ -663,7 +668,7 @@
     }
 
     Time previous = j->first;
-    NS_ABORT_IF(m_firstPowers.count(band) == 0);
+    NS_ABORT_IF(!m_firstPowers.contains(band));
     double noiseInterferenceW = m_firstPowers.at(band);
     double powerW = event->GetRxPowerW(band);
     while (++j != niIt.end())
@@ -814,17 +819,17 @@
 }
 
 void
-InterferenceHelper::NotifyRxStart()
+InterferenceHelper::NotifyRxStart(const FrequencyRange& freqRange)
 {
-    NS_LOG_FUNCTION(this);
-    m_rxing = true;
+    NS_LOG_FUNCTION(this << freqRange);
+    m_rxing[freqRange] = true;
 }
 
 void
 InterferenceHelper::NotifyRxEnd(Time endTime, const FrequencyRange& freqRange)
 {
     NS_LOG_FUNCTION(this << endTime << freqRange);
-    m_rxing = false;
+    m_rxing.at(freqRange) = false;
     // Update m_firstPowers for frame capture
     for (auto niIt = m_niChanges.begin(); niIt != m_niChanges.end(); ++niIt)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/interference-helper.h ns-3.42/src/wifi/model/interference-helper.h
--- ns-3.41/src/wifi/model/interference-helper.h	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/interference-helper.h	2024-05-29 15:29:47.204074000 -0700
@@ -208,6 +208,7 @@
      * \param ppdu the PPDU
      * \param duration the PPDU duration
      * \param rxPower received power per band (W)
+     * \param freqRange the frequency range in which the received signal is detected
      * \param isStartHePortionRxing flag whether the event corresponds to the start of the HE
      * portion reception (only used for MU)
      *
@@ -216,14 +217,18 @@
     Ptr<Event> Add(Ptr<const WifiPpdu> ppdu,
                    Time duration,
                    RxPowerWattPerChannelBand& rxPower,
+                   const FrequencyRange& freqRange,
                    bool isStartHePortionRxing = false);
 
     /**
      * Add a non-Wifi signal to interference helper.
      * \param duration the duration of the signal
      * \param rxPower received power per band (W)
+     * \param freqRange the frequency range in which the received signal is detected
      */
-    void AddForeignSignal(Time duration, RxPowerWattPerChannelBand& rxPower);
+    void AddForeignSignal(Time duration,
+                          RxPowerWattPerChannelBand& rxPower,
+                          const FrequencyRange& freqRange);
     /**
      * Calculate the SNIR at the start of the payload and accumulate
      * all SNIR changes in the SNIR vector for each MPDU of an A-MPDU.
@@ -277,13 +282,14 @@
 
     /**
      * Notify that RX has started.
+     * \param freqRange the frequency range in which the received signal event is detected
      */
-    void NotifyRxStart();
+    void NotifyRxStart(const FrequencyRange& freqRange);
     /**
      * Notify that RX has ended.
      *
      * \param endTime the end time of the signal
-     * \param freqRange the frequency range in which the received signal event had been detected
+     * \param freqRange the frequency range in which the received signal event was detected
      */
     void NotifyRxEnd(Time endTime, const FrequencyRange& freqRange);
 
@@ -346,6 +352,10 @@
                                             const WifiTxVector& txVector,
                                             uint16_t staId = SU_STA_ID) const;
 
+  protected:
+    std::map<FrequencyRange, bool>
+        m_rxing; //!< flag whether it is in receiving state for a given FrequencyRange
+
   private:
     /**
      * Noise and Interference (thus Ni) event.
@@ -422,10 +432,11 @@
      * Append the given Event.
      *
      * \param event the event to be appended
+     * \param freqRange the frequency range in which the received signal event is detected
      * \param isStartHePortionRxing flag whether event corresponds to the start of the HE portion
      * reception (only used for MU)
      */
-    void AppendEvent(Ptr<Event> event, bool isStartHePortionRxing);
+    void AppendEvent(Ptr<Event> event, const FrequencyRange& freqRange, bool isStartHePortionRxing);
 
     /**
      * Calculate noise and interference power in W.
@@ -511,7 +522,6 @@
     uint8_t m_numRxAntennas;         //!< the number of RX antennas in the corresponding receiver
     NiChangesPerBand m_niChanges;    //!< NI Changes for each band
     FirstPowerPerBand m_firstPowers; //!< first power of each band in watts
-    bool m_rxing;                    //!< flag whether it is in receiving state
 
     /**
      * Returns an iterator to the first NiChange that is later than moment
